// jsForm generator ************************
// formgen 0.2.17 14 January 2024
// free to use but no warranties
// El Condor - Condor Informatique - Turin
// *****************************************
if (typeof(window.$) != "function") var $ = function (id) {return document.getElementById(id);};  // wrap getElementById
formGen = function(idDiv,param,cBack) {
/* ************************* some functions *********************** */
	var sanitize = function(s) { // deMask , ; = &
		if (s.substring(0,1) == "@") s = aRep[s];
		return s.replace(/\\x2C|\\x3B|\\x3D|\\x26/gi,function(s){return String.fromCharCode(parseInt("0"+s.substring(1)))});
	};
	var splitKeyValue = function(aSplit) {	// return array of items
		var aRet = new Array();
		var a = new Array();
		for (var i in aSplit) {
			if (i == 0 || !/^\s*$/.test(aSplit[i])) {    // not empty (except the first one)
				if (aSplit[i].substr(0,1) == "@") {
					a = sanitize(aSplit[i]).split("=");
				} else {	
					a = aSplit[i].split("=");
					a[a.length-1] = sanitize(a[a.length-1])
				}
				a[0] = translate(fg_dictionary,a[0])
				if (a.length > 1) a[1] = translate(fg_dictionary,a[1])
				aRet[aRet.length] = [a[0],(a.length > 1) ? a[1]:a[0]];
			}
		}
		return aRet;
}
	var check = function(frm,widget) {	// can control all form or only the widget
		if (widget == undefined) var widget = "";
		var controls = formGen[frm.fg_Store.value].controls
		var aErrors = [];
		for (var field in controls) {
			var aItems = controls[field];
			if (field == "*") {		// general check
				var checkAnswer = window[aItems[0][1]](frm);
				if (checkAnswer != "") aErrors[aErrors.length] = checkAnswer;
				continue
			}
			if (widget != "" && widget.name != field) continue;
			var widgetValue = (widget == "") ? frm[field].value : widget.value;
			var clr = false;	// if error is red
			if (frm[field].style != undefined) frm[field].style.borderColor = "gray";
			for (k=0;k<aItems.length;k++) {
				switch (aItems[k][0]) {
					case "MIN":
						clr = (parseFloat(widgetValue) < parseFloat(aItems[k][1]));
						break;			
					case "MAX":
						clr = (parseFloat(widgetValue) > parseFloat(aItems[k][1]));
						break;
					case "PATTERN":
						if (widgetValue != "") {
							var regExpr = new RegExp(sanitize(aItems[k][1]));
							clr = (!regExpr.test(widgetValue));
						}
						break;
					case "MAIL":
						if (widgetValue != "") {
							clr = (!/^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,4}$/.test(widgetValue));
						}
						break;
					case "FUNCTION":
						clr = (!window[aItems[k][1]](frm,field,widgetValue));
						break;
					case "REQUIRED":
						clr = (/^\s*$/.test(widgetValue));
						break;
				}
				if (clr) {		// if error is red
					aErrors[aErrors.length] = field+": "+aItems[k][2];					
					if (frm[field].style != undefined) frm[field].style.borderColor = "red";
					clr = false;
					if (aItems[k][0] == "REQUIRED") break;
				}
			}
		}
		return aErrors;
	};
	var storeDefaults = function(item,def) {	// used for store defaults
		if (!Array.isArray(item)) item = item.split(",");
		for (var j=0;j<item.length; j++) {
			var itemDef = item[j].split(/\s*=/);
			if (itemDef.length == 2) {def[itemDef[0]] = sanitize(itemDef[1]);};
		}
	}
	var getOptionIndex = function (opt,value) {
	  for (var i = 0; i < opt.length; i++) {
		if (opt.options[i].text == value) return i;
		if (opt.options[i].value == value) return i;
	  }
	  return -1;
	}
	var createOptions = function(id,listItems) {	// lists and combos
		aItems = splitKeyValue(listItems.split(",").filter(r => r !== ''))
		aItems = splitKeyValue(listItems.split(","));	// clean list
		var opt = ""
		var group = "";		
		for (k=0;k<aItems.length;k++) {
			if (aItems[k][0] == "|") {
				opt += "<optgroup label='"+aItems[k][1]+"'>"
				group = aItems[k][1];
			} else {
				opt += "<option Value='" + aItems[k][0].replace(/'/g,"&#39;") + "'>" + aItems[k][1] + "</option>"
				if (group != "") listGroups[id+aItems[k][0]] = group;
			}
		}
		if ($(id) == null) return opt;	// when invoked in form building
		var x = $(id);
		if (x.type == "text") x = $(id+"_List");	// is LIST type
		x.innerHTML = opt;
		x.selectedIndex = -1
		return aItems.length
	}
	var addHidden = function(frm,name,value) {
		var hidden = document.createElement("input");
		hidden.setAttribute("type","hidden");
		hidden.setAttribute("name",name);
		if (value != undefined) hidden.setAttribute("value",value);
		frm.appendChild(hidden)
	}
	var	existsSubmitButton = function(aBtn) {	// checks if exists a submit button
		for (j in aBtn) {if (aBtn[j][0] == "BOTTOM" && !(/fg_Cancel$|fg_Reset$/.test(j))) return true;}
		return false;
	};
	var	existsBottomButtons = function(aBtn) {
		for (j in aBtn) {
			if (aBtn[j][0] == "BOTTOM") return true;
		}
		return false;
	}
	var genButton = function(frm,name,btn,events) {
		if (!(btn[3] in btnTypes)) return btn[4];
		btn[5] = translate(fg_dictionary,sanitize(btn[5]));
		if (name != "fg_Reset") {	// Reset button
			var rgxAlert = /^\s*alert:(.*)/i;
			let result = rgxAlert.exec(btn[4])	// test function is alert
			if (result !== null) {
				events[name] = Array("click","alert",translate(fg_dictionary,result[1]));
			} else {
				if(events[name] == undefined) events[name] = Array("click","formGen.prototype.handle",this.form,name,eval(btn[4]));
			}
		} else {
			if (events[name] == undefined) events[name] = Array("click","formGen.prototype.setDefaults")
		}
		var titleBtn = " title='" + btn[5] + "'";
		var idBtn = " id='" + frm + name + "'";
		var b = "\n<button type='button' name='" + name + "'" + titleBtn;
		b += ((btn[6] != "" &&  btn[3] != "IB") ? " style='width:" + btn[6] + "px'":"");	
		if (btn[3] == "GB" || btn[3] == "IB")
			b += " class='fg_GButton'><img src='" + btn[2] + "'"+idBtn +"></button>"
		else b += "' class='fg_Button'"+idBtn+">"+translate(fg_dictionary,btn[2])+"</button>"
		if (btn[3] == "IB") {
			b = b+"<span>"+translate(fg_dictionary,btn[5]) + "</span>";
		}
		return b;
	};	
	var hasAfterBelow = function(field,aBtns) {
		var r = "";		
		for (let j in aBtns) {
			if (field == aBtns[j][1]) {
				var id = jsForm[0]+field;
				if (aBtns[j][0] == "AFTER") return "<span id='"+id+"AFTER'></span>"
				else return "<div style='text-align:center' id='"+id+"BELOW'></div>";
			}
		}
		return r
	}
	var insertEraseMark = (id,name) => {
		events[name+"_fgErase"] = Array("click","formGen.prototype.handleClick");		// event for erase text fields
		return "<span style='margin-left:-11px;margin-right:5px' class='fg_Erase' title='Erase' id='"+id+"_fgErase'>&#x2718;</span>";
	}	
	var log10 = val => Math.log(val) / Math.LN10;
	var normalizeLabel = l => {
		l = l.replace(/(_[a-zA-Z])/, x => " " +x.substr(1,1).toLowerCase())		// aaa_bbb 
		l = l.replace(/([a-z])([A-Z])/, (mtch,p1,p2) => p1+" " +p2.toLowerCase())	// aaaBbb
		return l.substr(0,1).toUpperCase() + l.substr(1)
	}
	var setLabelClass = (label,tag) => "<"+tag+" class='fg_Label'>"+label+"</"+tag+">";
	var setValue = function(fld,value) {
		var field = widgets[fld];
		var id = jsForm[0]+fld;	// the name of control
		if (field[0] == "CKB") {
			if (value.toLowerCase() == "on" || value.toLowerCase() == "checked") $(id).checked = true;
			else $(id).checked = false;
		} else if (field[0] == "S") {
			if (value != "") $(id).value = value;
			$("s_"+id).innerHTML =  value;	// $(id).value;
		} else if (field[0] == "DATE") {
			if (value.toLowerCase() == "today") {
				$(id).value = formGen.prototype.timeStamp(new Date()).substr(0,10)
			}
		} else if (field[0] == "B" || field[0] == "GB") {
			if (value.toLowerCase() == "off") $(id).disabled = true;
		} else if (field[0] == "R") {
			$(id+value).checked = true;
		} else if (field[0] == "CMB" ) {
			$(id).selectedIndex = getOptionIndex($(id),value)
			if ($(id).selectedIndex > -1) {
				formGen.prototype.setGroupName($(id));
			} else {
				$(id+"_Exposed").value = ""
				$(id+"_Group").value = ""
			}
		} else if (field[0] == "I" || field[0] == "IC") {
			$(id).src = value;
		} else if (field[0] == "F") {
		} else {
			if ($(id) != null) {$(id).value = value;}
		}
	}
	formFields = function(frm,ret) {	// ret = true returns modified fields
		if (ret == undefined) var ret = false;
		var f = {};
		for (i = 0; i < frm.length; i++) {
			name = frm.elements[i].name;
			switch (frm.elements[i].type) {
				case "checkbox":
					f[name] = (frm.elements[i].checked)?frm.elements[i].value:"";
					var ckl = frm.elements[i].getAttribute("fg_CKL");
					if (ckl != null) {
						if (typeof f[ckl] == "string") f[ckl] = 0;	// the hidden field that generate f[ckl] is string
						if (frm.elements[i].checked) f[ckl] += 1
						frm[ckl].value = f[ckl];
					} 
					break;
				case "button":
					f[name] = (frm.elements[i].disabled)?"off":frm.elements[i].value;
					break;
				case "radio":
					if (frm.elements[i].checked) f[name] = frm.elements[i].value;
					break;
				case "hidden":
					if (name.substr(0,3) != "fg_") f[name] = frm.elements[i].value
					break;
				default:
					f[name] = frm.elements[i].value
			}
		}
		if (!ret) formFields.fieldsAtStart = f;
		else {
			for (const name in formFields.fieldsAtStart) {
				if (formFields.fieldsAtStart[name] == f[name]) delete f[name];
			}
			return Object.keys(f).join(",");
		}
}
	idNameSize = function (wdg,defaults) {		// prepare input field
		var ctrl = "id='"+jsForm[0]+wdg[1] + "' name='"+wdg[1] + "'";
		if ("NNSNF".indexOf(wdgType) == -1) ctrl += " size='" + +wdg[3] + "'"
		var extra = translate(fg_dictionary,wdg[4])
		if (wdgType.substr(0,1) == "U") {
			if (extra != "") defaults[wdg[1]] = extra;		// field value
			ctrl += " readonly class='fg_UType'";
		} else {
			if (extra != "") {
				ctrl += ((wdg[3] < extra.length) ? " title='":" placeholder='") + extra + "'"; // hint or title
			}
		}
		return ctrl;
	};
	myBeGenImgTag = function(txt) {
		const rgxIxmgFiles = /.+(\.png|\.gif|\.jpeg|\.jpg|\.gif|\.ico)$/mi;
		var rTxt = "";
		var aTxt = txt.split(":");
		for (let i = 0;i<aTxt.length;i++) {
			rTxt += (rgxIxmgFiles.test(aTxt[i])) ? "<img src='"+aTxt[i]+"'>": translate(fg_dictionary,aTxt[i]);
		}
		return rTxt
	}
/* ************************* end some functions *************************/
	if (idDiv.trim() == "") idDiv = "fg_PopUp";
	if(!$(idDiv)) {	// if div is not present is create as PopUp
		var link = document.createElement('DIV');
		link.setAttribute('id', idDiv);
		link.className = 'fg_PopUp';
		document.body.appendChild(link);
	}
	if (param == undefined) var param = $(idDiv).innerHTML;
	var callBack = "";
	if (cBack != undefined) callBack = cBack;
	if (param == "") param = "C,,Nodata!";
	var store = "fg_"+idDiv;	// must be here for output ID
	var widgets = {};			// widgets array
	var wType = {};				// name: type
	var defaults = {};
	var jsForm = new Array("","","","","","","T","fg_Form");			// what function?
	var llText = 50;			// limit from text and textarea
	var events = {}				// events array
	var comboEvents = {}		// links and change combo events
	var controls = {};			// controls
	var aGets = new(Array);		// GETs array
	var intervalHandlers = new Array();	// setInterval handlers
	var listGroups = new Array();	// Lists and combos group array
/************************** Check protected fields and remove cr\lf ******************************/	
	const regex = /[,=]?('(.*?)'|"(.*?)")[,;]/sm;
	var aRep = [0];		// array of replacements
	do {
	  param = (param + ";").replace(regex,(p1,p2,p3,p4) => {
			aRep[0] = aRep[0] + 1;
			var needle = (p3 == undefined) ? p4:p3;
			var rep = "@" + aRep[0] + "@";
			aRep[rep] = needle;		// .slice(1,-1)
			return p1.substring(0,1)+rep+p1.slice(-1);
		});
	} while (param.search(regex) > 0);
	var wdg = (param.replace(/\n|\r/g,"")).split(";");
/************************** End check protected fields and remove cr\lf ****************************/
	var convertType = {TEXT: "T", PSW: "P", LIST: "L", FILE:"F",SLIDER:"S",RDB:"R",RV:"R",IMG:"I",IMAGE:"I",
				COMMENT: "C",CONTROL: "CHECK",REQUIRED:"REQ",HIDDEN:"H",DEFAULTS:"DEFAULT",DICTIONARY:"DICT"}
// ****************** lacks of Date and Time
	var cTypes = {C:"fg_Comment",CE:"fg_Error",CS:"fg_Separator"}		// comments type
	var uTypes = {U:"fg_Comment",UN:"fg_Error"}							// not modifiable type
	var btnTypes = {B:"",GB:"",IB:""}	// buttons type
//	var resetTypes = "--T-N-NS-NF-P-L-F-S-CMB-CKL-R-CKB-DATE-TIME-"
	var okTypes = "--T-N-NS-NF-P-L-F-S-CKL-CKB-DATE-TIME-"
	var lengths = {S:150,NF:9,NS:7,N:6,IB:150,T:20,P:20,UN:6}	// if no length is provided is 20 characters for texts
//	var resetNeeded = 0;
// ******************************* start build *************************
	var i,j,k;
	var aButtons = {};
	fg_dictionary = {};
	for (let i=0;i<wdg.length; i++) {
		var field = wdg[i].split(",");
		if (field[0].substr(0,2) == "//") continue		// comment
		field[0] = field[0].toUpperCase();		// upper-case control name
		if (field[0] == "RV") field[3] = -1				// for vertical Radio buttons
		while (field.length < 7) field[field.length] = "";
		if (convertType[field[0]] != undefined) {field[0]  = convertType[field[0]]}
		if (field[0] == "FORM") {
			for (var j=1;j<field.length;j++) if (field[j] != "") jsForm[j-1] = field[j];
			if (jsForm[0] != "") jsForm[7] = jsForm[0];
		} else if (field[0] == "CHECK") {
			formGen.prototype.addControl(controls,field[1],field.slice(2))
		} else if (field[0] == "DEFAULT") {
			storeDefaults(field.slice(1),defaults);
		} else if (field[0] == "DICT") {
			fg_dictionary = eval(field[1]);
		} else if (field[0] == "LINK") {
			if (wType[field[1]] == undefined || wType[field[2]] == undefined) {
				wdg.push("CE,,"+field[1] + ' or ' + field[2]+ " doesn't exists")
			} else {
				if (wType[field[1]] != "CMB") [field[1], field[2]] = [field[2], field[1]]
				comboEvents[field[1]].LINK = Array(field[2],field[3]);
			}
		} else if (field[0] == "EVENT") {
			if (wType[field[1]] == "CMB") comboEvents[field[1]].CHANGE = field.slice(2);
			else events[field[1]] = field.slice(2);
		} else if (field[0] == "REQ") {
			for (var j=1;j<field.length; j++) formGen.prototype.addControl(controls,field[j],Array("required","required"));
		} else if (field[0] == "AFTER" || field[0] == "BELOW") {
			IDName = field[2];
			if (widgets[IDName] == undefined) wdg.push("CE,,AFTER BELOW: field "+IDName+ " doesn't exists")
			else if (widgets[field[1]] == undefined) wdg.push("CE,,AFTER BELOW: field "+field[1]+ " doesn't exists")
			else {
				if (aButtons[IDName] == undefined) {	// it is not a button
					aButtons[IDName] = [field[0],field[1],widgets[IDName][2],widgets[IDName][0],""];
				} else {
					aButtons[IDName][0] = field[0];
					aButtons[IDName][1] = field[1];
				}
			}
		} else if (field[0] == "GET") {
			field[2] = sanitize(field[2]);
			aGets.push(field);
		} else if (field[0] != "") {
			// normalization of parameters
			if (field[1] == "") field[1] = "fg_" + i;	// generated name
			var IDName = field[1];
			if (field[2] == "") field[2] = normalizeLabel(field[1]);	// label
			field[2] = sanitize(field[2]);	// normalize
			if  (field[3] == "" && " GBR".search(field[0]) == -1) {		// if lacks length
				if (lengths[field[0]] != undefined) {field[3]  = lengths[field[0]]}
			}
			if (field[0] == "S") {	// slider range and step
				if (field[4] == "") {field[4] = "0";field[5] = "100";field[6] = "1";}
				var min = Number(field[4]);
				var max = Number(field[5]);
				var delta = Math.abs(max-min);
				if (field[6] == "")
					field[6] = toString(1/(Math.pow(10,((Math.floor(log10(delta)-2) < 1)?-Math.floor(log10(delta)-2):0))));
				defaults[field[1]] = (max < min) ? min : min + 0.5 * (max - min)
			} else if (field[0].substr(0,2) == "NF") {	// floating point number
				field[6] = (Number(field[0].substr(2)) != NaN)? Number(field[0].substr(2)):0;
				field[0] = "NF";
			} else if (field[0] == "H") {
				defaults[field[1]] = sanitize(field[4]);
			} else if (field[0] == "CMB") {
				comboEvents[field[1]] = {}
			}
			widgets[IDName] = field;
			wType[field[1]] = field[0];
			if (field[0] in btnTypes) {
				aButtons[IDName] = Array("BOTTOM","",field[2],field[0],field[4],field[5],field[3])
			} else if (!field[0] in uTypes) {
					field[2] = field[0] + " Unknown type"
					field[0] = "CE"
			}
		}
	}
	translate = formGen.prototype.translate;
	var formID = jsForm[7];
	if($(formID)) {
		$(formID).parentNode.removeChild($(formID));	// if the form exists
	}
	frm = "<FORM id='"+jsForm[7]+"' method='POST'" + ((jsForm[2] != "" && jsForm[3] == "")?" action='"+jsForm[2]+"'":"") + ">";	
	frm += "\n<Table class='fg_Table'>";
	if (jsForm[1] != "") {	// title **************
		frm += "\n<tr><th class='fg_Title' colspan=3 id='"+jsForm[0]+"fg_Title'"
		frm += (idDiv == "fg_PopUp") ? " style='cursor:move'>":">";
		frm += myBeGenImgTag(jsForm[1]);
		frm += "</th></tr>";
	}
	var lonely = 0;		// 0 no widget, 1 only one CMB or Radio, > 1 widgets
	var aWidgets = Object.keys(widgets);
	for (let i = 0;i<aWidgets.length;i++) {
		field = widgets[aWidgets[i]];
		var [wdgType,fieldName,label,fieldLength,extra,extra2] = field;
		if (okTypes.indexOf("-"+wdgType+"-") > 0) lonely += 2;
		else {
			if (wdgType == "CMB" || wdgType == "R") {lonely += 1;lonField = field}
		}
		var IDName = jsForm[0]+fieldName;
		label = translate(fg_dictionary,label);
		const tdLabel = "\n<tr>"+setLabelClass(label,"td")+"<td>";
		if (wdgType in cTypes) {	// Comment fields
			if (aButtons[fieldName] == undefined)	frm += "\n<tr><td colspan='3'><div id='" +IDName + "' class='"+cTypes[wdgType]+"'>"+label+"</div>";
			else {
				aButtons[fieldName][4] = "\n<span id='" +IDName + "' class='"+cTypes[wdgType]+"'>"+label+"</span>";		// this is an after
			}
			continue;
		}
		if (wdgType == "IB") {	// Inline graphic button
			frm += "\n<tr><td colspan='3'>"+genButton(jsForm[0],fieldName,aButtons[fieldName],events)+hasAfterBelow(fieldName,aButtons)
			delete aButtons[fieldName];
			continue
		}
		if (wdgType == "I" || wdgType == "IC") {	// Image field
			if (defaults[fieldName] == undefined && extra != "") defaults[fieldName] = extra;
			var img = "<img style='vertical-align:middle' id='" +IDName + "' title='"+extra2 + "'";
			if(fieldLength != "") img+= " height='" + fieldLength+"'";
			img += "><span></span>";
			if (aButtons[fieldName] == undefined) {
				if (wdgType == "IC") {
					frm += "\n<tr><td colspan='3'>"+img;
				} else frm += tdLabel+img;
			} else {aButtons[fieldName][4] = img;}		// this is an after
			continue;
		}
		if (wdgType == "H") {
			frm += "\n<input type='hidden' id='" + IDName + "' name='"+fieldName +"' value='"+ extra +"'>";	// hidden field
			continue;
		}
		if (wdgType == "B") continue;
		if (aButtons[fieldName] == undefined) frm += tdLabel;	// is not an after	
		if (wdgType == "CKB") {								// Check box *******************
			var ckb = "<input type='checkbox' id='"+IDName+"' name='"+fieldName+"' value='on'> " + translate(fg_dictionary,extra);
			if (aButtons[fieldName] == undefined) frm += ckb;
			else {aButtons[fieldName][4] = setLabelClass(label,"span")+ckb;}		// this is an after
		} else if (wdgType == "CKL") {						// Check list ******************
			var aItems = splitKeyValue(field.slice(4));
			frm += "<input type='hidden' id='"+IDName + "' name='"+fieldName+"'/>"
			for (var ck=0;ck<aItems.length;ck++) {
				widgets[aItems[ck][0]] = ["CKB",aItems[ck][0]];	// complete widgets
				var ckb = "<input type='checkbox' fg_CKL='" + fieldName + "'"
				+ " id='"+jsForm[0]+aItems[ck][0]+"' name='"+aItems[ck][0]+"' value='On' /> " + aItems[ck][1];
				if (ck < aItems.length-1) ckb += "<br>";
				frm += ckb;
			}
			if (defaults[fieldName] != undefined) defaults[defaults[fieldName]] = 'On'
			defaults[fieldName] = 0
		} else if (wdgType == "CMB" || wdgType == "L") {	// combo and List **************
			if (wdgType == "CMB") {
				events[fieldName] = Array("change","formGen.prototype.handleEventOptions","",fieldName,comboEvents[fieldName]);
				var cmbWidth = (fieldLength != "")? "style='width:"+fieldLength+"px'":"";
				var cmb = "<input type='hidden' name='"+fieldName +"_Group' id='"+IDName + "_Group'/>"
				cmb += "<input type='hidden' name='"+fieldName +"_Exposed' id='"+IDName + "_Exposed'/>"
				+ "<SELECT id='"+IDName + "' name='"+fieldName +"' "+cmbWidth+">"+createOptions(IDName,field.slice(4).join(","))+"</SELECT>";
				if (aButtons[fieldName] == undefined) frm += cmb;
				else {aButtons[fieldName][4] = setLabelClass(label,"span")+cmb;}		// this is an after	
			} else {
				frm += "<input name='" + fieldName + "' id='" + IDName + "' list='" + IDName + "_List'/>"
				+ insertEraseMark(IDName,fieldName)
				+ "<datalist name='" + fieldName + "' id='" + IDName + "_List'>"+createOptions(IDName,field.slice(4).join(","))+"</datalist>"			
			}
		} else if (wdgType == "S") {							// ***************** Slider *********************
			frm += "\n<input type=range id='"+IDName + "' name='"+fieldName +"' min='"+extra+"' max='"+extra2 + "'"
			if (field[6] != 0) frm += " step='" + field[6] + "'";
			frm += " onChange='$(\"s_\"+this.id).innerHTML = this.value'";
			frm += " style='width:" + fieldLength + "px;vertical-align: middle'/>";
			frm += "<span id='s_" + IDName +"' style='display:inline-block;width:3em;padding-left:5px;vertical-align:middle'></span>";
		} else if (wdgType == "F") {					// File (before text!!! *************
			var accept = (extra != "") ? "accept='"+(field.slice(4)).join()+"' ":"";
			frm += "<input type=file " + accept + idNameSize(field) + "/>";
			jsForm[6] = "F";
		} else if (" TUNSNF".indexOf(wdgType) > 0) {		// T, U, UN, N, NS, NF **************
			if (fieldLength > llText) {
				frm += "<textarea cols=50 rows="+Math.ceil(fieldLength / llText);
				frm += " id='"+IDName + "' name='"+fieldName +"' class='fg_TextArea'></textarea>";
			} else {
				var txt = "";
				if (" N*NS*NF*UN*".indexOf(wdgType+"*") > 0) {
					txt += "\n<input type='number' " + idNameSize(field) + " style='text-align:right;width:" + fieldLength +"em'";
					if (wdgType == "NF") {
						txt += " inputmode='decimal' step='" + 1/Math.pow(10,Number(field[6])) + "'";
					} else {
						txt += " inputmode='numeric'";
						if (wdgType == "N") {
							txt += " min='0'";
							formGen.prototype.addControl(controls,fieldName,Array("Min=0","Must be unsigned integer"));
						}
					}
					txt += "/>";
				} else {
					txt += "<input type='text' " + idNameSize(field,defaults) + "/>";
					if (!(wdgType in uTypes)) {txt += insertEraseMark(IDName,fieldName);}
				}
				txt += translate(fg_dictionary,field[5]);
				if (aButtons[fieldName] == undefined) frm += txt;
				else {aButtons[fieldName][4] = setLabelClass(label,"span")+txt;}	// this is an after
			}
		} else if (wdgType == "P") {					// Password
			frm += "<input type=password " + idNameSize(field) + "/>"
				+ insertEraseMark(IDName,fieldName) + extra2
				+ "<span class='fg_CharButton' onClick='alert($(\"" + jsForm[0]+fieldName + "\").value)'>&#x1F441;</span>";

		} else if (wdgType == "R") {		// *************** Radio buttons *******************
			var aItems = splitKeyValue(field.slice(4));		// aItems is used also when lonely radiobuttons
			var evnt = ""
			if (events[fieldName] != undefined) {
				evnt = " on"+events[fieldName][0]+"='"+events[fieldName][1]+"(event)'";
				delete events[fieldName];
			}
			for (var ck=0;ck<aItems.length;ck++) {
				frm += "\n<input type='radio' name='"+fieldName+"' id='"+IDName+(ck) + "' value='"+ aItems[ck][0] + "'" +evnt +"/>";
				frm += ((Number(fieldLength) > 0) ? "<span style='display:inline-block;width:" + (fieldLength) + "px'>" +  myBeGenImgTag(aItems[ck][1]) + "</span>" : myBeGenImgTag(aItems[ck][1]));
				if (Number(fieldLength) == -1) frm +="<br>";	// vertical radio buttons
				if (defaults[fieldName] != undefined) {
					if (aItems[ck][0] == defaults[fieldName] || aItems[ck][1] == defaults[fieldName]) defaults[fieldName] = ck;
				}
			}
			frm += "\n<input type='radio' name='" + fieldName + "' id='" + IDName + "' value='' CHECKED style='display:none'>";
		} else if (wdgType == "DATE") {
			frm += "<input type='date' name='" + fieldName + "' id='" + IDName + "'>";
		} else {
		}
		frm += hasAfterBelow(fieldName,aButtons);
	}
	if (lonely != 1) {		// if no only list or radio button widget
		var isStatic = jsForm[4].toLowerCase() == "static";
		if (!existsSubmitButton(aButtons) && lonely > 1) {
			aButtons.fg_Ok = Array("BOTTOM","","Ok","B","","Send","")
		}
		if (lonely > 0 && aButtons.fg_Reset == undefined) {aButtons.fg_Reset = Array("BOTTOM","","Reset","B","","","")}
		if (aButtons.fg_Cancel == undefined && !isStatic) {aButtons.fg_Cancel = Array("BOTTOM","","Cancel","B","","","")}	// no cancel button if the form is static
		if (existsBottomButtons(aButtons)) {
			frm += "<tr><td colspan=2 style='text-align:center' class='fg_Buttons'>";	// buttons are centered
			frm += "<div id='"+jsForm[0]+"BOTTOM'></div>";
		}
	} else 	{
		if (existsBottomButtons(aButtons)) {
			frm += "<tr><td colspan=2 style='text-align:center' class='fg_Buttons'>";	// buttons are centered
			frm += "<div id='"+jsForm[0]+"BOTTOM'></div>";
		}
		if (lonField[0] == "R") {
			for (i=0;i<aItems.length;i++) {events[lonField[1]+(i)] = Array("click","formGen.prototype.handleSingle");}
		} else {
			// if single combo has event the form isn't exited
			cmbEvent = (events[lonField[1]] == undefined) ? {} : events[lonField[1]][4];
			if (!cmbEvent.hasOwnProperty('CHANGE')) events[lonField[1]] = Array("change","formGen.prototype.handleSingle");
		}
	}
	$(idDiv).innerHTML = frm+'</Table></FORM>';
	// add buttons	*********************
	for (j in aButtons) {
		$(jsForm[0]+aButtons[j][1]+aButtons[j][0]).innerHTML += genButton(jsForm[0],j,aButtons[j],events);
	}
	if (callBack != "") callBack("Before",jsForm[7]);
	//	 add hidden	*********************
	addHidden($(jsForm[7]),'fg_Button')
	addHidden($(jsForm[7]),'fg_Changed')
	addHidden($(jsForm[7]),'fg_Store',store)
	addHidden($(jsForm[7]),'fg_TimeStamp')
	// add controls	*********************
	for (field in controls) {
		if (field != "*") {		// general check
			if (widgets[field] == undefined) {
				alert ("Control " + field + " not exists")
				delete controls[field];
			} else {
				$(jsForm[0]+field).onblur = function(){var err = check(this.form,this);if (err != "") alert("Errors:\n"+err.join("\n"))};
				
			}
		}
	}
 // store object variables
	formGen[store] = {jsForm: jsForm,
			defaults: defaults, 
			widgets: widgets, 
			controls: controls,
			listGroups: listGroups,
			createOptions:createOptions,
			callBack: callBack,
			check:check,
			buttons:aButtons,
			intervalHandlers:intervalHandlers,
			setValue:setValue
			};
// add events ***************************************************
	for (var name in events) {
		var e = events[name];		
		eField = jsForm[0]+name
		if ($(eField) == null) {console.log(eField + ": event field not present");return}
		if (e[1].trim() == "") {console.log(eField + ": function not present");return}
		if (e[0].toLowerCase() == "enter") e[0] = "keyup";
		if (e[1].substr(0,8) == "formGen." || typeof window[e[1]] == "function") {
			if (e[1].toLowerCase() == "alert") $(eField).addEventListener(e[0],function(alrt){alert(alrt)}.bind(event,translate(fg_dictionary,e[2])));
			else {
				$(eField).addEventListener(e[0],eval(e[1]).bind(event,$(jsForm[7]),e[3],e[4]));
			}
		} else {
			if (e[1].toLowerCase() == "submit") {
				if (e[0] == "keyup") $(eField).addEventListener(e[0],eval("formGen.prototype.handleEnter"));
				else $(eField).addEventListener(e[0],eval("formGen.prototype.handleSingle"));
			} else {				
				if ($(jsForm[7]+e[2]) instanceof Element || $(e[2]) instanceof Element) {
					if (!($(e[2]) instanceof Element)) e[2] = jsForm[7]+e[2];
					$(eField).addEventListener(e[0],eval("formGen.prototype.ajax").bind(event,e[1],$(jsForm[7]),e[2]));
				}  else if (typeof window[e[2]] == "function")	{// js function
					$(eField).addEventListener(e[0],eval("formGen.prototype.ajax").bind(event,e[1],$(jsForm[7]),eval(e[2]),e[3]));
				}
			}
		}
	}
/********************  handle GET pseudo type ********************/
	var handleGetAnswer = function(c,frm,parms) {
		ajaxEvents--;
		var [name,timeout] = parms
		if (name != "*") {		
			var fld = $(jsForm[0]+name);
			if (fld == null) console.log(name + " get field not present")
			else if (widgets[name][0] == "CMB" || widgets[name][0] == "L") {createOptions(jsForm[0]+name,c)}	// get combo items
			else if (widgets[name][0] in cTypes) fld.innerHTML = c
			else if (widgets[name][0] == "I" || widgets[name][0] == "IC") {	// image
				var a = c.split(/\t/);
				if (timeout > 0) fld.src = a[0];
				if(defaults[name] == undefined) defaults[name] = a[0];
				fld.src = a[0];
				if (a.length > 1) fld.nextSibling.innerHTML = "  "+a[1];
			} else {
				if (timeout > 0) fld.value = c;	// text I suppose
				if(defaults[name] == undefined) defaults[name] = c;	// sets default also when is first call
			}
		} else {	// defaults
			storeDefaults(c,formGen[store].defaults)
		}
	}
	var ajaxEvents = aGets.length;	// count Get pseudo types for list and default
	var totalWait = aGets.length * 2000
	for (var i=0;i<aGets.length;i++) {
		var [,name, url,timeout] = aGets[i];	// GET,[* | name],URI[,timeout
		formGen.prototype.ajax(url,"",handleGetAnswer,Array(name,timeout));
		var millisecs = parseInt(timeout,10);
		if (isNaN(millisecs)) millisecs = 0;
		if (millisecs > 0) {
			intervalHandlers.push(setInterval(formGen.prototype.ajax,millisecs,url,"",handleGetAnswer,Array(name,timeout)));
		}
	}
	function delay(ms) {return new Promise(resolve => setTimeout(resolve, ms));}
	async function  waitAjax() {
		var dt = Date.now()
		while (ajaxEvents > 0) {
			await delay(500);
			totalWait -= 500
			if (totalWait < 0) {
				alert("Ajax timeout after "+totalWait * aGets.length + " ms");
				break;
			}
		}
		formGen.prototype.setDefaults($(formID));	// set defaults
		if (callBack != "") callBack("Start",formID);
		formGen[store].fieldsAtStart = formFields($(formID));	// save initial form values
	}
	waitAjax(totalWait);
	return {
		createOptions:createOptions,
		check:check,
		formFields:formFields,
		setValue,setValue,
		fg_FormID: formID
	}
};
formGen.prototype.IDEvent = function(e) {
	if(window.event) return event.srcElement.id;	// IE
	else return e.target.id;  						// Netscape/Firefox/Opera
}
formGen.prototype.handleEventOptions = function (frm,linkField,comboEvents) {
	if (comboEvents.LINK != undefined) {
		var eValue = event.target.value;
		linkField = comboEvents.LINK[0]
		if (comboEvents.LINK[1].toLowerCase() == "value") {eValue = event.target.options[event.target.selectedIndex].text;}
		if (frm[linkField].type == "textarea") {
			var k = frm[linkField].selectionStart;
			var areaValue = frm[linkField].value;
			frm[linkField].value = areaValue.substring(0,k) + eValue + areaValue.substring(k);
		} else frm[linkField].value = eValue;
	}
	if (comboEvents.CHANGE != undefined) {
		var fnz = comboEvents.CHANGE[1]
		if (fnz.toLowerCase() == "submit") {
			formGen.prototype.handleSingle(frm)
			return
		} else if (fnz.toLowerCase() == "alert") {
			alert(comboEvents.CHANGE[2])
		} else if (typeof window[fnz] == "function")	{	// js function
			window[fnz](frm,comboEvents.CHANGE[2],comboEvents.CHANGE[3],comboEvents.CHANGE[4])
		} else {
			formGen.prototype.ajax(fnz,frm,comboEvents.CHANGE[2],comboEvents.CHANGE[3]);	// server function
		}
	}
	formGen.prototype.setGroupName(event.target);
}
formGen.prototype.handleSingle = function (frm) {	// for capture single combo
	if (event.target.tagName == "SELECT") {
		formGen.prototype.setGroupName(event.target);
	}
	event.stopImmediatePropagation();
	formGen.prototype.handle(event.target.form,event.target.id);
}
formGen.prototype.setGroupName = function (opt) {	// set the possible combo group name
	var listGroups = formGen[opt.form.fg_Store.value].listGroups
	$(opt.id + "_Group").value = listGroups[opt.id + opt.options[opt.selectedIndex].value];
	$(opt.id + "_Exposed").value = opt.options[opt.selectedIndex].label;
}
formGen.prototype.handleEnter = function () {	// for capture enter key
	if (event.key == "Enter") formGen.prototype.handle(event.target.form,event.target.id,"submit");
}
formGen.prototype.handle = function (frm,button,customHandler) {	// send request
	if (customHandler == undefined) customHandler = "";
	var store = frm.fg_Store.value;
	var jsForm = formGen[store].jsForm;
	var aButtons = formGen[store].buttons;
	if (button.substr(0,jsForm[0].length) == jsForm[0]) button = button.substr(jsForm[0].length)
	frm.fg_Button.value = button;
	btnPosition = (aButtons[button] != undefined) ? aButtons[button][0] : "";
	frm.fg_Changed.value = formFields(frm,true);
	if (button != "fg_Cancel" && (customHandler == "submit" || btnPosition == "BOTTOM")) {
		var aErrors = formGen[store].check(frm);		// data control ******************
		if (aErrors.length > 0) return alert("Errors:\n"+aErrors.join("\n"));
	}
	// set names of modified fields
	frm.fg_TimeStamp.value = formGen.prototype.timeStamp(new Date());
	if (customHandler != "") {		// button handled
		if (customHandler != "submit") return customHandler(frm,jsForm[2],jsForm[3]);
	}
	var formParms ={"URI":jsForm[2],"ajaxFunction":jsForm[3],"action": jsForm[4].toLowerCase(),
					"erase":false,"container":store.substr(3),"store":store,"target":jsForm[5].toLowerCase()}
	if (button == "fg_Cancel") formParms.erase = true;
	else {
		if (formParms.target == "" || formParms.target == "_self") {
			if(formParms.action != "reset" && formParms.action != "static") formParms.erase = true;
		}
	}
	if (formParms.URI != "" && formParms.ajaxFunction == "") {		// only URI
		if (button != "fg_Cancel") {
			if (jsForm[6] == "F") frm.encoding = "multipart/form-data";	// for files
			frm.action = formParms.URI;
			if (formParms.target != "") frm.target = formParms.target == "newwindow"?"_blank":formParms.target;
			frm.submit();
		}
	} else if (formParms.URI == "" && formParms.ajaxFunction != "") {		// only call function
		if (button == "fg_Cancel") {
			var form = document.createElement("form");
			form.setAttribute("id",frm.id);
			form.setAttribute("method",frm.method);
			$(formParms.container).replaceChild(form,frm);
			frm.fg_Button.value = "fg_Cancel";
		}
		window[jsForm[3]](frm);
	} else if (formParms.URI != "" && formParms.ajaxFunction != "") {		// call Ajax receive in function
		if (jsForm[6] == "F") frm.encoding = "multipart/form-data";	// for files
		if (button == "fg_Cancel") {					//	27 IX 2020
			frm.innerHTML ="<input type=hidden name=fg_Button value='fg_Cancel'>"
		}
		formGen.prototype.ajax(jsForm[2],frm,window[formParms.ajaxFunction]);
	} else {														// no uri no function
		if (button == "fg_Cancel") {
			frm.innerHTML ="<input type=hidden name=fg_Button value='fg_Cancel'>"
		}
		if (formParms.action != "static") $(jsForm[7]).innerHTML = formGen.prototype.getData(frm);
		return
	}
	if (formParms.erase) {
		$(frm.id).parentNode.removeChild($(frm.id));
		formGen[store].intervalHandlers.map(h => clearInterval(h));
		if (formGen[store].callBack != "") formGen[store].callBack("End",jsForm[7])
	} else {
		if(formParms.action == "reset") setTimeout(function(){formGen.prototype.setDefaults(frm)},100);
		if (formGen[store].callBack != "") formGen[store].callBack("AfterSubmit",jsForm[7])
	}
}
formGen.prototype.ajax = function(url,frm,handler,parms) {
	var data = (typeof(frm) == "string")? frm :new FormData(frm);
	var ajx = new XMLHttpRequest();
	ajx.onreadystatechange = function(){
		if (ajx.readyState == 4) {
			if (ajx.status == 200) {				
				if ($(handler) instanceof Element) {
					switch ($(handler).nodeName) {
						case "IMG":
							var a = ajx.responseText.split(/\t|:/);
							$(handler).src = a[0];
							if (a.length > 1 && $(handler).nextSibling != null) $(handler).nextSibling.innerHTML = a[1]; 
							break;
						case "INPUT":
						case "TEXTAREA":
							$(handler).value = ajx.responseText;
							break;
						case "SELECT":
							formGen[frm.fg_Store.value].createOptions(handler,ajx.responseText);
							break;
						default:
							$(handler).innerHTML = ajx.responseText;							
					}
				} else if(typeof handler == "function") return handler(ajx.responseText,frm,parms)
				else console.log(handle,"is neither function nor id of tag")
			}
			else alert("Error: " + ajx.status + ": " + ajx.statusText);
		}
	}
	ajx.open("POST", url, true)
	if (typeof data != "object") {ajx.setRequestHeader("Content-type", "application/x-www-form-urlencoded")}
	ajx.send(data);
}
formGen.prototype.dropCommaSemicolon = function(s) { // deMask , ; = &
	 if (s.substring(0,1) == "@") s = aRep[s];
	 return s.replace(/\\x2C|\\x3B|\\x3D|\\x26/gi,function(s){return String.fromCharCode(parseInt("0"+s.substr(1)))});
};
formGen.prototype.getData = function(frm) {
	var r = "<div style='text-align:center;cursor:pointer' onclick='this.innerHTML=\"\"'><table border=1 cellpadding='5'>";
	for (i = 0; i < frm.length; i++) {
		c1 = "<tr><td>"+frm.elements[i].name+"<td>";
		switch (frm.elements[i].type) {
			case "checkbox":
				r += c1+((frm.elements[i].checked)?frm.elements[i].value:"");
				break;
			case "radio":
				if (frm.elements[i].checked) r += c1+frm.elements[i].value;
				break;
			case "button":
				break;
			default:
				r += c1+frm.elements[i].value;
		}
	}
	return r+"</table>&#x2718;</div>";
}
formGen.prototype.setDefault = function(frm,widget,value) {	// form, widget and value
	var store = $(frm).fg_Store.value
	var defaults = formGen[store].defaults;
	defaults[widget] = value;
}
formGen.prototype.setDefaults = function(frm,widget) {	// form and widget if only one field to set
	var store = frm.fg_Store.value
	var defaults = formGen[store].defaults;
	var widgets = formGen[store].widgets;
	for (i in widgets) {
		var [,name] = widgets[i];
		if (widget != name && widget != undefined) continue;
		if (defaults[name] != undefined) formGen[store].setValue(name,defaults[name])
		else formGen[store].setValue(name,"")
	}
}
formGen.prototype.addControl = function(controls,name,control) {
	if (name == "") return;
	if (controls[name] == undefined) a = Array()
	else a = controls[name];
	for (var i=0;i<control.length;i=i+2) {
		if (control[i] == "") break;
		var aItems = ["","",(i==control.length)?"":control[i+1]];	// signal
		var a2 = control[i].split("=");
		aItems[0] = a2[0].toUpperCase();	// "MIN","MAX","MAIL","PATTERN","REQUIRED","FUNCTION"
		if (a2.length > 1) {
			aItems[1] = a2[1]
		}
		a[a.length] = aItems;
	}
	controls[name] = a;
}
formGen.prototype.handleClick = function(frm) {	
	var targ = event.target;
	if (targ.innerHTML == "\u2718" && targ.localName == "span") {	// Unicode delete
		formGen.prototype.setDefaults(frm,targ.previousSibling.name);
	}
}
formGen.prototype.translate = (obj,w) => (obj[w] == undefined) ? w: obj[w].replace("\n","<br>");
formGen.prototype.timeStamp = function(d) {return d.toISOString().slice(0,19).replace("T"," ")}